//+------------------------------------------------------------------------
//
//  Copyright @ Baris TAZE
//
//  File:     DefinitionsGA.h
//
//  Content:  Constant definitions
//  
//  Classes:  CIndividual
//            
//  History:  27-May-2002    created by baris taze .  
//
//-------------------------------------------------------------------------

#pragma once

#define GA_SET_DEF_CROSSOVERRATE	0.60f
#define GA_SET_DEF_MUTATIONRATE		0.001f
#define GA_SET_DEF_POPSIZE			1000

#define GA_CROSSOVER_ONEPOINT		1
#define GA_CROSSOVER_TWOPOINT		2
#define GA_CROSSOVER_UNIFORM		3

#define GA_CRSOVR_DEF_UNIFORM_CHANCE 0.10f

#define GA_NATSEL_ROULETTE			1
#define GA_NATSEL_STOCHASTIC		2
#define GA_NATSEL_GENITOR			3
#define GA_NATSEL_TOURNAMENT		4

#define GA_NATSEL_DEF_GENITOR		20
#define GA_NATSEL_DEF_TOURNAMENT	0.75f

#define AUTO_STOP_CRITERIA_MANUEL			1<<1
#define AUTO_STOP_CRITERIA_BIAS				1<<2
#define AUTO_STOP_CRITERIA_MINUTE			1<<3
#define AUTO_STOP_CRITERIA_ITERATION		1<<4
#define AUTO_STOP_CRITERIA_REFINEMENT		1<<5

#define DEF_AUTO_STOPBY_BIAS		0.90f
#define DEF_AUTO_STOPBY_MINUTE		5
#define DEF_AUTO_STOPBY_ITERATION	3000
#define DEF_AUTO_STOPBY_REFINEMENT	50
